APP = rcsj_gpu_fp64

CXX=g++
#CXX=clang++

SRC_DIR=./

CXXFLAGS=-c -Wall -std=c++2a -O3

CXXFLAGS+=-DCLGPU -I /include

CXXFLAGS+=-DTIME_CHECK
#CXXFLAGS+=-DOUT_CONSOLE

LDFLAGS=

OPTIONS += -lOpenCL
CXXFLAGS+=-march=native
CXXFLAGS+=-mavx
CXXFLAGS+=-funroll-all-loops 
CXXFLAGS+=-unroll-loops 
CXXFLAGS+=-omit-frame-pointer 
CXXFLAGS+=-fno-stack-protector

SRCS=$(wildcard ${SRC_DIR}*.cpp)
APP_OBJS = $(SRCS:.cpp=.o)

all: $(SRCS) $(APP)

$(APP): $(APP_OBJS)
	$(CXX) $(LDFLAGS) $(APP_OBJS) -o $@ $(OPTIONS)

$(SRCS).o:
	$(CXX) $(INCLUDE) $(CXXFLAGS) $< -o $@

clean:
	rm -rf ${SRC_DIR}*.o $(APP) ${SRC_DIR}*.elf ${SRC_DIR}*.gdb
